script_name("Mission Loader")
script_author("Grinch_")
script_description("Mission Loader for GTA San Andreas")
script_dependencies("imgui")
script_version("1.0")

-- Script Dependencies
local imgui       = require 'imgui'
local glob        = require 'game.globals'

local tmain =
{
    window         = imgui.ImBool(false),
    menu_open_cheat= "MISSION",
	current_btn    = 1,
    search_text    = imgui.ImBuffer(24),
    array          = {},
}


local tmissions = {

    --[0]	    = "Initial 1",
    --[1]	    = "Initial 2",
    [2]	    = "Intro",
    [3]	    = "They Crawled From Uranus",
    [4]	    = "Dualuty",
    [5]	    = "Go Go Space Monkey",
    [6]	    = "Lets Get Ready To Bumble",
    [7]	    = "Inside Track Betting",
    --[8]	    = "Pool",
    [9]	    = "Lowrider (Bet And Dance)",
    [10]	= "Beefy Baron",
    [11]	= "Big Smoke",
    [12]	= "Ryder",
    [13]	= "Tagging Up Turf",
    [14]	= "Cleaning The Hood",
    [15]	= "Drive-Thru",
    [16]	= "Nines And AKs",
    [17]	= "Drive-By",
    [18]	= "Sweets Girl",
    [19]	= "Cesar Vialpando",
    [20]	= "Los Sepulcros",
    [21]	= "Doberman",
    [22]	= "Burning Desire",
    [23]	= "Gray Imports",
    [24]	= "Home Invasion",
    [25]	= "Catalyst",
    [26]	= "Robbing Uncle Sam",
    [27]	= "OG Loc",
    [28]	= "Running Dog",
    [29]	= "Wrong Side of the Tracks",
    [30]	= "Just Business",
    [31]	= "Lifes a Beach",
    [32]	= "Madd Doggs Rhymes",
    [33]	= "Management Issues",
    [34]	= "House Party",
    [35]	= "Race Tournament / 8-track / Dirt Track",
    --[36]	= "Lowrider (High Stakes)",
    [37]	= "Reuniting The Families",
    [38]	= "The Green Sabre",
    [39]	= "Badlands",
    [40]	= "First Date",
    [41]	= "Local Liquor Store",
    [42]	= "Small Town Bank",
    [43]	= "Tanker Commander",
    [44]	= "Against All Odds",
    [45]	= "King in Exile",
    [46]	= "Body Harvest",
    [47]	= "Are you going to San Fierro?",
    --[48]	= "Wu Zi Mu / Farewell, My Love...",
    [49]	= "Wear Flowers In Your Hair",
    [50]	= "Deconstruction",
    [51]	= "555 WE TIP",
    [52]	= "Snail Trail",
    [53]	= "Mountain Cloud Boys",
    [54]	= "Ran Fa Li",
    [55]	= "Lure",
    [56]	= "Amphibious Assault",
    [57]	= "The Da Nang Thang",
    [58]	= "Photo Opportunity",
    [59]	= "Jizzy",
    [60]	= "Outrider",
    [61]	= "Ice Cold Killa",
    [62]	= "Torenos Last Flight",
    [63]	= "Yay Ka-Boom-Boom",
    [64]	= "Pier 69",
    [65]	= "T-Bone Mendez",
    [66]	= "Mike Toreno",
    [67]	= "Zeroing In",
    [68]	= "Test Drive",
    [69]	= "Customs Fast Track",
    [70]	= "Puncture Wounds",
    [71]	= "Back to School",
    [72]	= "Air Raid",
    [73]	= "Supply Lines",
    [74]	= "New Model Army",
    [75]	= "Monster",
    [76]	= "Highjack",
    [77]	= "Interdiction",
    [78]	= "Verdant Meadows",
    [79]	= "N.O.E.",
    [80]	= "Stowaway",
    [81]	= "Black Project",
    [82]	= "Green Goo",
    [83]	= "Learning to Fly",
    [84]	= "Fender Ketchup",
    [85]	= "Explosive Situation",
    [86]	= "Youve Had Your Chips",
    [87]	= "Fish in a Barrel",
    [88]	= "Don Peyote",
    [89]	= "Intensive Care",
    [90]	= "The Meat Business",
    [91]	= "Freefall",
    [92]	= "Saint Marks Bistro",
    [93]	= "Misappropriation",
    [94]	= "High Noon",
    [95]	= "Madd Dogg",
    [96]	= "Architectural Espionage",
    [97]	= "Key To Her Heart",
    [98]	= "Dam And Blast",
    [99]	= "Cop Wheels",
    [100]	= "Up, Up and Away!",
    [101]	= "Breaking the Bank at Caligulas",
    [102]	= "A Home In The Hills",
    [103]	= "Vertical Bird",
    [104]	= "Home Coming",
    [105]	= "Cut Throat Business",
    [106]	= "Beat Down on B Dup",
    [107]	= "Grove 4 Life",
    [108]	= "Riot",
    [109]	= "Los Desperados",
    [110]	= "End Of The Line (1)",
    [111]	= "End Of The Line (2)",
    [112]	= "End Of The Line (3)",
    --[113]	= "Shooting range",
    --[114]	= "Los Santos Gym Fight School",
    --[115]	= "San Fierro Gym Fight School",
    --[116]	= "Las Venturas Gym Fight School",
    [117]	= "Trucking",
    [118]	= "Quarry",
    --[119]	= "Boat School",
    --[120]	= "Bike School",

    -- Sub-Missions
    --[121]	= "Taxi-Driver",
    --[122]	= "Paramedic",
    --[123]	= "Firefighter",
    --[124]	= "Vigilante",
    --[125]	= "Burglary",
    --[126]	= "Freight Train",
    --[127]	= "Pimping",
    [128]	= "Blood Ring",
    [129]	= "Kickstart",
    [130]	= "Beat the Cock!",
    --[131]	= "Courier",
    --[132]	= "The Chiliad Challenge",
    --[133]	= "BMX / NRG-500 STUNT Mission",
    --[134]	= "Buy Properties Mission",
}

for i = 0,#tmissions,1 do
    if tmissions[i] ~= nil then
        table.insert(tmain.array,i)
    end
end

function imgui.OnDrawFrame()
	if  tmain.window.v then

		imgui.SetNextWindowSize(imgui.ImVec2(350, 600),  imgui.Cond.FirstUseEver)

		imgui.Begin(string.format( '%s v%s by Grinch_',script.this.name,script.this.version),tmain.window,imgui.WindowFlags.NoCollapse)
		
		CreateButtons({"LS","SF","LV","Desert","Misc","Search"},{LS,SF,LV,Desert,Misc,Search})

        imgui.End()
    end
end

function LS()
    ShowMissionEntries('Big smoke',{27,28,29,30})
    ShowMissionEntries('Carl johnson',{103,104,105})
    ShowMissionEntries('Catalina',{40})
    ShowMissionEntries('Cesar vialpando',{45})
    ShowMissionEntries('Frank tenpenny',{22,23,39})
    ShowMissionEntries('Introduction',{11,12})
    ShowMissionEntries('OG loc',{31,32,33,34})
    ShowMissionEntries('Riot',{108,109,110,111,112})
    ShowMissionEntries('Robbery',{41,42,43,44})
    ShowMissionEntries('Ryder',{24,25,26})
    ShowMissionEntries('Sweet',{13,14,15,16,17,18,19,20,21,37,38,106,107})
    ShowMissionEntries('The truth',{46,47})
end

function SF()
    ShowMissionEntries('Carl johnson',{49,50,51})
    ShowMissionEntries('Frank tenpenny',{52})
    ShowMissionEntries('Loco syndicate',{58,59,60,61,62,63,64,65,66})
    ShowMissionEntries('Wang cars',{67,68,69,70,71})
    ShowMissionEntries('WuZiMu',{53,54,55,56,57})
    ShowMissionEntries('Zero',{72,73,74})
end

function LV()
    ShowMissionEntries('Caligulas casino',{89,90,91,92})
    ShowMissionEntries('Frank tenpenny',{93,94})
    ShowMissionEntries('Heist',{96,97,98,99,100,101})
    ShowMissionEntries('Madd dogg',{95})
    ShowMissionEntries('The four dragons casino',{84,85,86,87,88,102})
end

function Desert()
    ShowMissionEntries('Mike toreno',{75,76,77,78})
    ShowMissionEntries('Verdant meadows airstrip',{79,80,81,82,83})
end

function Misc()
    ShowMissionEntries('Arena missions',{128,129,130})
    ShowMissionEntries('Miscellaneous',{117,118})
    ShowMissionEntries('Video games',{3,4,5,6,7,9,10})
end

function Search()
    imgui.Columns(1)
    if imgui.InputText('Search ',tmain.search_text) then 
    end
    imgui.Spacing()
    imgui.Text("Found missions :(" .. tmain.search_text.v .. ")")
    imgui.Separator()
    imgui.Spacing()
    if imgui.BeginChild("MissionsEntries") then
        ShowMissionEntries(nil,tmain.array,tmain.search_text.v)
        imgui.EndChild()
    end
end

function CreateButtons(names,func)

    local X = imgui.GetWindowWidth()/3 - 7*imgui.StyleVar.WindowPadding
    imgui.GetStyle().ItemSpacing = imgui.ImVec2(0.0,0.0)
	for i=1,#names,1 do
		
		if i == tmain.current_btn then
			imgui.GetStyle().Colors[imgui.Col.Button] = imgui.ImVec4(0.06,  0.53,  0.98,  1.00)
		end

		if imgui.Button(names[i],imgui.ImVec2(X,25)) then
			tmain.current_btn = i
		end

		imgui.GetStyle().Colors[imgui.Col.Button] = imgui.ImVec4(0.26,  0.59,  0.98,  0.40)

        if i%3 ~= 0 then
            imgui.SameLine(0.0,0.0)
		end

    end
    imgui.GetStyle().ItemSpacing = imgui.ImVec2(3.0,3.0)
    
    imgui.Dummy(imgui.ImVec2(0,10))
    if imgui.Button("Fail current mission",imgui.ImVec2(imgui.GetWindowWidth()-21,25)) then
        if isPlayerControlOn(PLAYER_HANDLE) then
            failCurrentMission()
            printBig("M_FAIL",5000,1)
        else
            printString("Unable to fail mission",5000)
        end
    end
    imgui.Dummy(imgui.ImVec2(0,10))
    if imgui.BeginChild("") then
        func[tmain.current_btn]()
        imgui.EndChild()
    end

end

function MissionEntry(i)
    if imgui.MenuItem(tmissions[i]) then
        if getGameGlobal(glob.ONMISSION) == 0 then
            clearWantedLevel(PLAYER_HANDLE)
            lockPlayerControl(true)
            doFade(true,1000)
            loadAndLaunchMissionInternal(i)
            lockPlayerControl(false)
        else
            printHelpString('Already in a mission')
        end
    end
end

function ShowMissionEntries(title,list,search_text)
    if search_text == nil then search_text = "" end

    if title ~= nil then
        if imgui.CollapsingHeader(title) then
            imgui.Spacing()
            for _,i in pairs(list) do
                if search_text == "" or ((string.upper(tmissions[i])):find(string.upper(search_text)) ~= nil) then
                    MissionEntry(i)
                end
            end
            imgui.Separator()
            imgui.Spacing()
        end
    else
        imgui.Spacing()
        for _,i in pairs(list) do
            if search_text == "" or ((string.upper(tmissions[i])):find(string.upper(search_text)) ~= nil) then
                MissionEntry(i)
            end
        end
        imgui.Separator()
        imgui.Spacing()
    end

end

function main()
	ApplyStyle()

	while true do
		if testCheat(tmain.menu_open_cheat) then
			tmain.window.v = not tmain.window.v
		end

        imgui.Process = tmain.window.v
        wait(0)
	end
end

function ApplyStyle()
    imgui.SwitchContext()
    local style = imgui.GetStyle()
    local colors = style.Colors
    local clr = imgui.Col
    local ImVec4 = imgui.ImVec4

    style.WindowRounding = 2.0
	style.WindowTitleAlign = imgui.ImVec2(0.5,  0.84)
	style.ChildWindowRounding = 2.0
	style.FrameRounding = 0.0
	style.ItemSpacing = imgui.ImVec2(3.0,  3.0)
	style.ScrollbarSize = 12.0
	style.ScrollbarRounding = 2.0
	style.GrabMinSize = 8.0
	style.GrabRounding = 1.0
    style.WindowPadding = imgui.ImVec2(10.0,  10.0)
	colors[clr.Text]                   = ImVec4(1.00,  1.00,  1.00,  1.00)
	colors[clr.TextDisabled]           = ImVec4(0.50,  0.50,  0.50,  1.00)
	colors[clr.WindowBg]               = ImVec4(0.06,  0.06,  0.06,  0.94)
	colors[clr.ChildWindowBg]          = ImVec4(1.00,  1.00,  1.00,  0.00)
	colors[clr.PopupBg]                = ImVec4(0.08,  0.08,  0.08,  0.94)
	colors[clr.ComboBg]                = colors[clr.PopupBg]
	colors[clr.Border]                 = ImVec4(0.43,  0.43,  0.50,  0.50)
	colors[clr.BorderShadow]           = ImVec4(0.00,  0.00,  0.00,  0.00)
	colors[clr.FrameBg]                = ImVec4(0.16,  0.29,  0.48,  0.54)
	colors[clr.FrameBgHovered]         = ImVec4(0.26,  0.59,  0.98,  0.40)
	colors[clr.FrameBgActive]          = ImVec4(0.26,  0.59,  0.98,  0.67)
	colors[clr.TitleBg]                = ImVec4(0.04,  0.04,  0.04,  1.00)
	colors[clr.TitleBgActive]          = ImVec4(0.16,  0.29,  0.48,  1.00)
	colors[clr.TitleBgCollapsed]       = ImVec4(0.00,  0.00,  0.00,  0.51)
	colors[clr.MenuBarBg]              = ImVec4(0.14,  0.14,  0.14,  1.00)
	colors[clr.ScrollbarBg]            = ImVec4(0.02,  0.02,  0.02,  0.53)
	colors[clr.ScrollbarGrab]          = ImVec4(0.31,  0.31,  0.31,  1.00)
	colors[clr.ScrollbarGrabHovered]   = ImVec4(0.41,  0.41,  0.41,  1.00)
	colors[clr.ScrollbarGrabActive]    = ImVec4(0.51,  0.51,  0.51,  1.00)
	colors[clr.CheckMark]              = ImVec4(0.26,  0.59,  0.98,  1.00)
	colors[clr.SliderGrab]             = ImVec4(0.24,  0.52,  0.88,  1.00)
	colors[clr.SliderGrabActive]       = ImVec4(0.26,  0.59,  0.98,  1.00)
	colors[clr.Button]                 = ImVec4(0.26,  0.59,  0.98,  0.40)
	colors[clr.ButtonHovered]          = ImVec4(0.26,  0.59,  0.98,  1.00)
	colors[clr.ButtonActive]           = ImVec4(0.06,  0.53,  0.98,  1.00)
	colors[clr.Header]                 = ImVec4(0.26,  0.59,  0.98,  0.00)
	colors[clr.HeaderHovered]          = ImVec4(0.26,  0.59,  0.98,  0.80)
	colors[clr.HeaderActive]           = ImVec4(0.26,  0.59,  0.98,  1.00)
	colors[clr.Separator]              = colors[clr.Border]
	colors[clr.SeparatorHovered]       = ImVec4(0.26,  0.59,  0.98,  0.78)
	colors[clr.SeparatorActive]        = ImVec4(0.26,  0.59,  0.98,  1.00)
	colors[clr.ResizeGrip]             = ImVec4(0.26,  0.59,  0.98,  0.25)
	colors[clr.ResizeGripHovered]      = ImVec4(0.26,  0.59,  0.98,  0.67)
	colors[clr.ResizeGripActive]       = ImVec4(0.26,  0.59,  0.98,  0.95)
	colors[clr.CloseButton]            = ImVec4(0.41,  0.41,  0.41,  0.50)
	colors[clr.CloseButtonHovered]     = ImVec4(0.98,  0.39,  0.36,  1.00)
	colors[clr.CloseButtonActive]      = ImVec4(0.98,  0.39,  0.36,  1.00)
	colors[clr.PlotLines]              = ImVec4(0.61,  0.61,  0.61,  1.00)
	colors[clr.PlotLinesHovered]       = ImVec4(1.00,  0.43,  0.35,  1.00)
	colors[clr.PlotHistogram]          = ImVec4(0.90,  0.70,  0.00,  1.00)
	colors[clr.PlotHistogramHovered]   = ImVec4(1.00,  0.60,  0.00,  1.00)
	colors[clr.TextSelectedBg]         = ImVec4(0.26,  0.59,  0.98,  0.35)
	colors[clr.ModalWindowDarkening]   = ImVec4(0.80,  0.80,  0.80,  0.35)
end